/* ----------------------------------------------------------------- */
/* UPCO ICAI - Departamento de Electrnica y Automtica              */
/* ----------------------------------------------------------------- */
/* Programa tipos1: Estudio de los tipos bsicos                     */
/*                                                                   */
/* Descripcin: Estudia los rangos y tamaos de los tipos bsicos    */
/*                                                                   */
/* Autor: Jos Antonio Rodrguez Mondejar                            */
/* Fecha: 19 / 06 / 1998                                             */
/* Versin: 1.0                                                      */
/*                                                                   */
/* ----------------------------------------------------------------- */

#include <stdio.h>
#include <limits.h>
#include <float.h>

void InfTipos(void);

int main()
{
	InfTipos();

	return 0;

/* ----------------------------------------------------------------- */
/*                                                                   */
/* void InfTipos(void)                                               */
/*                                                                   */
/* Descripcin: Devuelve informacin sobre los tipos bsicos         */
/*                                                                   */
/* Argumentos:                                                       */
/*                                                                   */
/* Devuelve:                                                         */
/*                                                                   */
/* ----------------------------------------------------------------- */

void InfTipos(void)
{
	char c=0;
	unsigned char uc=0;
	int i=0;
	unsigned int ui=0;
	long int l=0;
	unsigned long ul=0;

	printf("Tipos bsicos en coma fija\n");
	printf("--------------------------\n");
	
	c=~c;					/* T1 */
	printf("char:\t\t[%d,%d]\t\t\t%d\t\t%u bytes\n",CHAR_MIN,CHAR_MAX,c,sizeof(c));

	uc=~uc;					/* T2 */
	printf("unsigned char:\t[%u,%u]\t\t\t\t%u\t\t%u bytes\n",0U,UCHAR_MAX,uc,sizeof(uc));

	i=~i;					/* T3 */
	printf("int:\t\t[%d,%d]\t\t\t%d\t\t%u bytes\n",INT_MIN,INT_MAX,i,sizeof(i));

	ui=~ui;					/* T4 */
	printf("unsigned int:\t[%u,%u]\t\t\t%u\t\t%u bytes\n",0U,UINT_MAX,ui,sizeof(ui));

	l=~l;					/* T5 */
	printf("long int:\t[%ld,%ld]\t%ld\t\t%u bytes\n",LONG_MIN,LONG_MAX,l,sizeof(l));

	ul=~ul;					/* T6 */
	printf("unsigned long:\t[%lu,%lu]\t\t\t%lu\t%u bytes\n",0UL,ULONG_MAX,ul,sizeof(ul));

	printf("\n");
	printf("Tipos bsicos en coma flotante\n");
	printf("------------------------------\n");

						/* T7 */
	printf("float:\t\t[%g,%g]\t%g\t%u bytes\n",FLT_MIN,FLT_MAX,FLT_EPSILON,sizeof(float));

						/* T8 */
	printf("double:\t\t[%g,%g]\t%g\t%u bytes\n",DBL_MIN,DBL_MAX,DBL_EPSILON,sizeof(double));
}